SoPointSet(3)

NAME
SoPointSet - The SoPointSet class is used to display a set of 3D points.

SYNOPSIS

#include <Inventor/nodes/SoPointSet.h>

Inherits SoNonIndexedShape.

Inherited by SoMarkerSet.

  Public Member Functions
virtual SoType getTypeId (void) const
SoPointSet (void)
virtual void GLRender (SoGLRenderAction *action)
virtual void getBoundingBox (SoGetBoundingBoxAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)

  Public Attributes
SoSFInt32 numPoints

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoPointSet ()
virtual void generatePrimitives (SoAction *action)
virtual void computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)
virtual SbBool generateDefaultNormals (SoState *, SoNormalCache *nc)
virtual SbBool generateDefaultNormals (SoState *state, SoNormalBundle *bundle)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoPointSet class is used to display a set of 3D points. This node either uses the coordinates currently on the state (typically set up by a leading SoCoordinate3 node in the scene graph) or from a SoVertexProperty node attached to this node to render a set of 3D points.

The SoPointSet::numPoints field specifies the number of points in the coordinate set which should be rendered (or otherwise handled by traversal actions).

Here's a simple usage example of SoPointSet in a scene graph:

#Inventor V2.1 ascii
Separator {
   Material {
      diffuseColor [
       1 0 0, 0 1 0, 0 0 1, 1 1 0, 1 0 1, 1 1 1, 1 0.8 0.6, 0.6 0.8 1
      ]
   }
   MaterialBinding { value PER_PART }
   Coordinate3 {
      point [
       -1 1 0, -1 -1 0, 1 -1 0, 1 1 0, 0 2 -1, -2 0 -1, 0 -2 -1, 2 0 -1
      ]
   }
   DrawStyle { pointSize 3 }
   PointSet { }
}

FILE FORMAT/DEFAULTS:

PointSet {
    vertexProperty NULL
    startIndex 0
    numPoints -1
}

Constructor & Destructor Documentation

  SoPointSet::SoPointSet (void)
Constructor.

  SoPointSet::~SoPointSet () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoPointSet::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoPointSet::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoNonIndexedShape.

Reimplemented in SoMarkerSet.

  const SoFieldData ** SoPointSet::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoPointSet::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoNonIndexedShape.

Reimplemented in SoMarkerSet.

  void SoPointSet::initClass (void) [static]

  void SoPointSet::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoShape.

Reimplemented in SoMarkerSet.

  void SoPointSet::getBoundingBox (SoGetBoundingBoxAction * action) [virtual]
Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoShape.

  void SoPointSet::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoShape.

Reimplemented in SoMarkerSet.

  void SoPointSet::generatePrimitives (SoAction * action) [protected], [virtual]
The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

  void SoPointSet::computeBBox (SoAction * action, SbBox3f & box, SbVec3f & center) [protected], [virtual]
Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box.

The bounding box and center point should be calculated and returned in the local coordinate system.

The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().)

The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry.

Implements SoShape.

  SbBool SoPointSet::generateDefaultNormals (SoState * state, SoNormalCache * cache) [protected], [virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Subclasses should override this method to generate default normals using the SoNormalCache class. This is more effective than using SoNormalGenerator. Return TRUE if normals were generated, FALSE otherwise.

Default method just returns FALSE.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented from SoVertexShape.

  SbBool SoPointSet::generateDefaultNormals (SoState * state, SoNormalBundle * bundle) [protected], [virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Subclasses should override this method to generate default normals using the SoNormalBundle class. TRUE should be returned if normals were generated, FALSE otherwise.

Default method returns FALSE.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented from SoVertexShape.

Member Data Documentation

  SoSFInt32 SoPointSet::numPoints
Used to specify number of points in the point set. Coordinates for the points will be taken from the state stack's set of 3D coordinates, typically set up by a leading SoCoordinate3 node.

If this field is equal to -1 (the default value) all coordinates currently on the state will be rendered or otherwise handled by traversal actions.

SoPointSet inherits the field SoNonIndexedShape::startIndex, which specifies the start index for points from the current state set of coordinates. Please note that this field has been obsoleted, but is still provided for compatibility.

Author

Generated automatically by Doxygen for Coin from the source code.